#include "myheaders.h"

//vector to hold calculated tree positions
Vector3 trees[100];

int startbuildingx = 0;
int startbuildingy = 0;


//array of buildings in environment
vector<Building> skyscrapers;

void CalcTreePos()
{
	for(int i = 0; i < 10; i++)
	{
		skyscrapers.push_back(Building(-rand() % 35 - 5, .5, rand() % 35 + 5, 3, 0));
	}
}

void init_buildings()
{
	skyscrapers.push_back(Building(7.5, 2, 7.5, 1, 0));
	skyscrapers.push_back(Building(15, 2, 7.5, 2, 0));
	skyscrapers.push_back(Building(22.5, 1, 7.5, 5, 0));
	skyscrapers.push_back(Building(31, 1, 7.5, 6, 0));
	skyscrapers.push_back(Building(7.5, 1, 15, 7, 0));
	skyscrapers.push_back(Building(7.5, 2, 25, 2, 0));
	skyscrapers.push_back(Building(30, 2, 30, 1, 0));
	skyscrapers.push_back(Building(15, 2, 15.5, 2, 0));
	skyscrapers.push_back(Building(20, 1, 15.5, 5, 0));
	skyscrapers.push_back(Building(25, 1, 25.5, 5, 0));
	skyscrapers.push_back(Building(40, 2, 15.5, 1, 0));
	skyscrapers.push_back(Building(7.5, 2, 40, 1, 0));
	skyscrapers.push_back(Building(10.5, 2, 35, 2, 0));
	skyscrapers.push_back(Building(15.5, 2, 30, 5, 0));
}

void DrawTrees()
{
	for(int i = 0; i < 100; i++)
	{
		glPushMatrix();
			glTranslatef(trees[i].x, trees[i].y+.4, trees[i].z);
			DrawTree();
		glPopMatrix();
	}
}


void DrawStreetLights(float y)
{

	for(int i = -50; i < 50; i+= 10)
	{
		glPushMatrix();
			glTranslatef(2.75, 0, i);
			if(i != 0)
			{
				DrawStreetLight(y);
			}
		glPopMatrix();
	}

	for(int i = -50; i < 50; i+= 10)
	{
		glPushMatrix();
			glTranslatef(-2.75, 0, i);
			if(i != 0)
			{
				DrawStreetLight(y);
			}
		glPopMatrix();
	}

}

void DrawBuildings()
{
	for(int i = 0; i < skyscrapers.size(); i++)
	{
		glPushMatrix();
		glTranslatef(skyscrapers[i].x, skyscrapers[i].y , skyscrapers[i].z);
		glScalef(skyscrapers[i].scale, 1, skyscrapers[i].scale);
		glRotatef(skyscrapers[i].rotate, 0, 1, 0);
		if(skyscrapers[i].type == 1)
		{
			DrawSkyscraper();
		}
		if(skyscrapers[i].type == 2)
		{
			DrawSkyscraper1();
		}
		if(skyscrapers[i].type == 3)
		{
			DrawTree();
		}
		if(skyscrapers[i].type == 4)
		{
			DrawStreetLight(-1);
		}
		if(skyscrapers[i].type == 5)
		{
			DrawSkyscraper2();
		}
		if(skyscrapers[i].type == 6)
		{
			DrawWideBuilding();
		}
		if(skyscrapers[i].type == 7)
		{
			DrawWideBuilding1();
		}
		if(skyscrapers[i].type == 8)
		{
			DrawBuilding2();
		}
		glPopMatrix();
	}
}

void AddBuilding(int type)
{
	skyscrapers.push_back(Building(0, 0, 0, type, 1));
	
}

void TranslateBuilding(int x, int y)
{
	for(int i = 0; i < skyscrapers.size(); i++)
	{
		if(skyscrapers[i].editable == 1)
		{
			skyscrapers[i].x -= ((float)startbuildingx - x)/50;
			skyscrapers[i].z -= ((float)startbuildingy - y)/50;
		}
	}
	startbuildingx = x;
	startbuildingy = y;
}

void RotateBuilding(int x, int y)
{
	for(int i = 0; i < skyscrapers.size(); i++)
	{
		if(skyscrapers[i].editable == 1)
		{
			skyscrapers[i].rotate += ((float)startx - x)/50;
		}
	}
	startbuildingx = x;
	startbuildingy = y;
}


void SetBuildings()
{
	for(int i = 0; i < skyscrapers.size(); i++)
	{
		skyscrapers[i].editable = 0;
	}
	startbuildingx = 0;
	startbuildingy = 0;
}

void SetBuildingStart(int x, int y)
{
	startbuildingx = x;
	startbuildingy = y;
}
