//basic program to read in a mesh file (of .m format from H. Hoppe)
//Hh code modified by ZJW for csc 471




#include "myheaders.h"


Vector3 light_vector;
int rotateCam;
//int startx, starty;

float phi;
float theta;
float sunPos;

float eyeX, eyeY, eyeZ;
void rotate(int, int);
void strafeLeft();
void strafeRight();
void zoomIn();
void zoomOut();
void calcView();
void calcStrafe();
void calcCloudPos();
void DrawClouds();

/*initialize menus */
void doMenus();
void process_mainmenu(int);


Vector3 view;
Vector3 strafeV;
Vector3 LA;
Vector3 Eye;

int GW;
int GH;
int display_mode;
int view_mode;
int trans_mode;
int pause_sun;
int light;




//forward declarations of functions

void display();
void init_lighting();
void pos_light();
void reshape();
void mouse();
void mouseMove();
void keyboard();
void init_cam();



/** LIGHT CONTROLS **/

//globals for lighting - use a white light and apply materials
//light position
GLfloat light_pos[4] = {0, 0, 0, 1.0};
//light color (ambiant, diffuse and specular)
//GLfloat light_amb[4] = {.5, .5, .5, 1.0};
GLfloat light_amb[4] = {.1, .1, .1, 1.0};
GLfloat light_diff[4] = {.8, .8, .8, 1.0};
GLfloat light_spec[4] = {.5, .5, .5, 1.0};
GLfloat global_ambient[4] ={.2, .2, .2, 1.0};
GLfloat light_dir[3] = {0, -1, 0};


//initialization calls for opengl for static light
//note that we still need to enable lighting in order for it to work
//see keyboard 'l' event
void init_lighting() {
  //turn on light0
  glEnable(GL_LIGHT0);
  //set up the diffuse, ambient and specular components for the light
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diff);
  glLightfv(GL_LIGHT0, GL_AMBIENT, light_amb);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_spec);

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
  //specify our lighting model as 1 normal per face
  glShadeModel(GL_SMOOTH);
  glEnable(GL_NORMALIZE);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

}
void CalcSunPos()
{
	float sunX = 48*cos(sunPos);
	float sunY = 48*sin(sunPos);
	if(sunX > 0 && sunY > 0)
	{
		sunX++;
		sunY++;
	}
	else if(sunX < 0 && sunY > 0)
	{
		sunX--;
		sunY++;
	}
	else if(sunX < 0 && sunY < 0)
	{
		sunX--;
		sunY--;
	}
	else if(sunX > 0 && sunY < 0)
	{
		sunX++;
		sunY--;
	}
	glTranslatef(sunX, sunY, 0);
}
void orbit_sun()
{
	if(!pause_sun)
	{
		sunPos+=.001f;
		light_vector.x = 40 * cos(sunPos);
		light_vector.y = 40 * sin(sunPos);
		light_vector.z = 0;
		adjust_sky(light_vector.x, light_vector.y);
		glutPostRedisplay();
	}
	//printf("x %f y %f z %f\n", light_vector.x, light_vector.y, light_vector.z);
}

void pos_light() 
{
  //set the light's position

	light_pos[0] = light_vector.x;
	light_pos[1] = light_vector.y;
	light_pos[2] = 0;
	if(light_pos[1] < 0)
	{
		glDisable(GL_LIGHT0);
	}
	if(light_pos[1] >= 0)
	{
		glEnable(GL_LIGHT0);
	}
	//light_dir[0] =  -light_vector.x;
	//light_dir[1] = -light_vector.y;
	//light_dir[2] =  0;



   glMatrixMode(GL_MODELVIEW);


    glLightfv(GL_LIGHT0, GL_POSITION, light_pos);

	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, light_dir);



	//glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, .5);


  
/*
	if(light_vector.y < 0)
	{
		glLighti(GL_LIGHT0, GL_SPOT_CUTOFF, 0);
	}
	else
	{
		glLighti(GL_LIGHT0, GL_SPOT_CUTOFF, light_vector.y + 40);
	}
*/
  //printf("%f\n", light_vector.y + 40);



}







/** CAMERA CONTROLS **/

// calculate the view vector
// this is the view vector - the eye vector
void calcView()
{
	float normal;
	view.x = LA.x - Eye.x;
	view.y = LA.y - Eye.y;
	view.z = LA.z - Eye.z;

	normal = sqrt(view.x*view.x + view.y*view.y + view.z*view.z);

/*
	view.x = view.x/normal;
	view.y = view.y/normal;
	view.z = view.z/normal;
*/



	//printf("view %f %f %f\n", view.x, view.y, view.z);

}

// calculate strafe vector
// strafe is the cross product of the view and up vectors
void calcStrafe()
{
	float normal = sqrt(view.z*view.z + view.x*view.x);
	strafeV.x = -view.z;
	strafeV.y = 0;
	strafeV.z = view.x;

	//printf("strafe %f %f %f\n", strafeV.x, strafeV.y, strafeV.z);

}

// pitch and yaw controls for camera
void rotate(int x, int y)
{
	float radius;
	phi += (((float)GH-y-1 - starty))/10;
	theta += (((float)x - startx))/10;




	if(phi > 50)
	{
		phi = 50;
	}
	if(phi < -50)
	{
		phi = -50;
	}

	if(abs(theta) > 360)
	{
		theta = 0;
	}

	//radius = 10;
	radius = sqrt(view.x*view.x + view.y*view.y + view.z*view.z);
	

	LA.x =  Eye.x + radius *  cos(phi * 3.14 / 180) * cos(theta * (2*3.14/360));
	LA.y =  Eye.y + radius * sin(phi* (2*3.14/360));
	LA.z =  Eye.z + radius * cos(phi* (2*3.14/360)) * cos((90 - theta) * (2*3.14/360));

	calcView();
	calcStrafe();

	//printf("eyex %f eyey %f eyez %f\n", eyeX, eyeY, eyeZ);
	//printf("phi %f theta %f lookAtX %f lookAtY %f lookAtZ %f radius %f\n", phi, theta, lookAtX, lookAtY, lookAtZ, radius);
	//printf("viewx %f viewy %f viewz %f\n", view.x, view.y, view.z);

	starty = GH-y-1;
	startx = x;

}

//move camera forward
void zoomIn()
{
	float normal = sqrt(view.x*view.x + view.y*view.y + view.z*view.z);

	Eye.x += view.x/normal;
	Eye.y += view.y/normal;
   Eye.z += view.z/normal;
	LA.x += view.x/normal;
	LA.y += view.y/normal;
   LA.z += view.z/normal;

	//printf("eyex %f eyey %f eyez %f\n", eyeX, eyeY, eyeZ);
	//printf("lookx %f looky %f lookz %f\n", lookAtX, lookAtY, lookAtZ);
	//printf("eyex %f eyey %f eyez %f\n", eyeX, eyeY, eyeZ);
	//printf("viewx %f viewy %f viewz %f\n", view.x, view.y, view.z);
}

// move camera backward
void zoomOut()
{
	float normal = sqrt(view.x*view.x + view.y*view.y + view.z*view.z);

	Eye.x -= view.x/normal*.1;
	Eye.y -= view.y/normal*.1;
   Eye.z -= view.z/normal*.1;
	LA.x -= view.x/normal*.1;
	LA.y -= view.y/normal*.1;
   LA.z -= view.z/normal*.1;

}

// translate camera to the left along strafe vector
void strafeLeft()
{	
	calcStrafe();
	Eye.x -= strafeV.x/25;
	Eye.y -= strafeV.y/25;
   Eye.z -= strafeV.z/25;
	LA.x -= strafeV.x/25;
	LA.y -= strafeV.y/25;
   LA.z -= strafeV.z/25;
}

// translate camera to the right along strafe vector
void strafeRight()
{
	calcStrafe();
	Eye.x += strafeV.x/25;
	Eye.y += strafeV.y/25;
   Eye.z += strafeV.z/25;
	LA.x += strafeV.x/25;
	LA.y += strafeV.y/25;
   LA.z += strafeV.z/25;
}



// reshape func
void reshape(int w, int h) {
  GW = w;
  GH = h;
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
	//ortho
  if (view_mode == 0)
    glOrtho( -2.0*(float)w/h, 2.0*(float)w/h, -2.0, 2.0, 1.0, 15.0);
	//perspective
  else
  {
	 gluPerspective(70, (float)w/h, 1.0, 100.0);
  }
  glMatrixMode(GL_MODELVIEW);
  glViewport(0, 0, w, h);
  
  glutPostRedisplay();
}





// mouse func
void mouse(int button, int state, int x, int y) {
  startx = x;
  starty = GH-y-1;

  if (button == GLUT_LEFT_BUTTON) {
    if (state == GLUT_DOWN) { /* if the left button is clicked */
      printf("mouse clicked at %d %d\n", x, GH-y-1);
		if(move_building != 1)
		{
			rotateCam = 1;
		}
		if(move_building)
		{
			SetBuildingStart(x, y);
		}

    }
	 if(state == GLUT_UP)
	 {
		rotateCam = 0;
	 } 
  }
}

void mouseMove(int x, int y) {
  //printf("mouse moved at %d %d\n", x, GH-y-1);

  if(rotateCam)
  {
      rotate(x, y);
  }
  if(move_building)
  {
	  if(trans_mode == 1)
	  {
			TranslateBuilding(x, y);
	  }
	  else if(trans_mode == 2)
	  {
		  RotateBuilding(x, y);
	  }
  }
  glutPostRedisplay();
}



//the keyboard callback
void keyboard(unsigned char key, int x, int y ){
  switch( key ) {

	 case 'a': case 'A' :
		//printf("strafe left\n");
		strafeLeft();
		break;

	 case 'd': case 'D' :
		//printf("strafe right\n");
		strafeRight();
		break;

	 case 'w': case 'W' :
		//printf("zoom in\n");
		zoomIn();
		break;

	 case 's': case 'S' :
		//printf("zoom in\n");
		zoomOut();
		break;

    case 'q': case 'Q' :
      exit( EXIT_SUCCESS );
      break;
	 case 'e': case'E':
		printf("toggle display mode\n");
		display_mode = !display_mode;
		break;
   case 'l': case 'L':
    light = !light;
    if (light)
      glEnable(GL_LIGHTING);
    else
      glDisable(GL_LIGHTING);
    break;
	 case 'v': case'V':
		printf("toggle display mode\n");
		view_mode = !view_mode;
		reshape(GW, GH);
		break;

	 case 'r': case'R':
		printf("toggle display mode\n");
		init_cam();
		break;
	 case 'p': case 'P':
		printf("pause toggled\n");
		pause_sun = !pause_sun;
		break;


  }
	glutPostRedisplay();
}


void init_cam()
{

	Eye.x = 0;
	Eye.y = 2;
  	Eye.z = 3.0;

	LA.x= LA.y = LA.z = 0;

	phi = 0;
	theta = -90;


	calcView();
	calcStrafe();
}

//display func
void display() {
  
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glMatrixMode(GL_MODELVIEW);
    
  glPushMatrix();
  //set up the camera

  	gluLookAt(Eye.x, Eye.y, Eye.z, LA.x, LA.y, LA.z, 0, 1, 0);
  glPushMatrix();

  pos_light();
  glPopMatrix();

	glPushMatrix();
		//glDisable(GL_LIGHTING);
		CalcSunPos();
  		DrawSun();
		//glEnable(GL_LIGHTING);
	glPopMatrix();


	DrawBuildings();
	DrawStreetLights(light_vector.y);
	//DrawTrees();
	DrawSkyDomeMesh();
	DrawTerrain();
	DrawFloor();
	if(light_vector.y < 2)
	{
  		DrawStars();
	}

  glPopMatrix();

  glutSwapBuffers();
    
}


void process_mainmenu(int value) 
{
	if(value == 1)
	{

	}
	if(value == 3)
	{
		move_building = 0;
		SetBuildings();
		init_cam();
		trans_mode = 0;
	}
}

void BuilderView()
{
	Eye.x = 0;
	Eye.y = 35;
	Eye.z = 35;
	LA.x = 0;
	LA.y = 0;
	LA.z = 0;
}

void process_buildingmenu(int value)
{
	if(value == 1)
	{
		AddBuilding(1);

	}
	if(value == 2)
	{
		AddBuilding(2);

	}
	if(value == 3)
	{
		AddBuilding(5);
	}
	if(value == 4)
	{
		AddBuilding(6);
	}
	if(value == 5)
	{
		AddBuilding(7);
	}
	if(value == 6)
	{
		AddBuilding(8);
	}
	move_building = 1;
	BuilderView();
}

void process_objectsmenu(int value)
{
	if(value == 1)
	{
		AddBuilding(3);

	}
	if(value == 2)
	{
		AddBuilding(4);

	}
	move_building = 1;
	BuilderView();
}

void process_toolsmenu(int value)
{
	trans_mode = value;
}

void doMenus()
{
	int mainmenu, buildingmenu, objectsmenu, tools;
	buildingmenu = glutCreateMenu(process_buildingmenu);
	glutAddMenuEntry("Skyscraper Type 1", 1);
	glutAddMenuEntry("Skyscraper Type 2", 2);
	glutAddMenuEntry("Skyscraper Type 3", 3);
	glutAddMenuEntry("Wide Building Type 1", 4);
	glutAddMenuEntry("Wide Building Type 2", 5);
	glutAddMenuEntry("Wide Building Type 3", 6);

	tools = glutCreateMenu(process_toolsmenu);
	glutAddMenuEntry("Translate", 1);
	glutAddMenuEntry("Rotate", 2);

	objectsmenu = glutCreateMenu(process_objectsmenu);
	glutAddMenuEntry("Tree", 1);
	glutAddMenuEntry("Street Lighting", 2);

	mainmenu = glutCreateMenu(process_mainmenu);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
	glutAddSubMenu("Buildings", buildingmenu);
	glutAddSubMenu("Objects", objectsmenu);
	glutAddSubMenu("Transforms", tools);

	glutAddMenuEntry("Set Building", 3);
	//glutAddMenuEntry("rotate", 3);
	
	
}
void init_world()
{
	//CalcTreePos();
	init_buildings();
	CalcSkyDomeVertices();
	CalcStars();
}

int main( int argc, char** argv ) {
  
  //set up my window
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
  glutInitWindowSize(800, 800); 
  glutInitWindowPosition(100, 100);
  glutCreateWindow("Final Project");
  glClearColor(1.0, 1.0, 1.0, 1.0);
  
  //register glut callback functions
  glutDisplayFunc( display );
  glutReshapeFunc( reshape );
  glutKeyboardFunc( keyboard );
  glutMouseFunc(mouse);
  glutMotionFunc(mouseMove);
  glutIdleFunc(orbit_sun);
  //initialization


  display_mode = 1;
	pause_sun = 0;
  view_mode = 1;
  light = 1;
  trans_mode = 0;
  rotateCam = 0;
  startx = 0;
  starty = 0;
  sunPos = 0;
	move_building = 0;

  //enable GL features we want
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_LIGHTING);
  //only do this once
  init_lighting();
	doMenus();
	init_cam();
	init_tex();
	light_vector.x = 0;
	light_vector.y = 0;
	light_vector.z = 0;
  init_world();
  LoadTexture("sky.bmp", 1);
  LoadTexture("concrete.bmp",2);
  LoadTexture("sky1.bmp", 3);
  LoadTexture("grass.bmp", 4);
  LoadTexture("building1.bmp", 5);
  LoadTexture("building2.bmp", 6);
  LoadTexture("roofmetal.bmp", 7);
  LoadTexture("building3.bmp", 8);
  LoadTexture("building4.bmp", 9);
  LoadTexture("building5.bmp", 10);
  LoadTexture("marble.bmp", 11);
  glutMainLoop();
}

